/* SMC.h */

/*
 * (C) Copyright 1989,1990
 * All Rights Reserved
 *
 * Alan R. Baldwin
 * 721 Berkeley St.
 * Kent, Ohio  44240
 *
 * Modified for SMC88
 * (c) Copyright 1995
 *
 * Altair in Planning Group "HALO"
 * NBG01720@niftyserve.or.jp
 */

/*
 * Indirect Addressing delimeters
 */
#define LFIND	'['
#define RTIND	']'

/*
 * Registers
 */
#define A		0	/*R8[]*/
#define B		1
#define L		2
#define H		3

#define BR		0	/*R8X[]*/
#define SC		1
#define NB		8
#define EP		9
#define XP		0xA
#define YP		0xB

#define BA		0	/*R16[]*/
#define HL		1
#define IX		2
#define IY		3
#define SP		8
#define PC		9

#define IP		6	/*R16X[]*/
#define ALL  0x18
#define ALE  0x19

/*
 * Conditional definitions
 */
#define LT		0
#define LE		1
#define GT		2
#define GE		3
#define V		4
#define NV		5
#define P		6
#define M		7
#define F0		8
#define F1		9
#define F2	  0xA
#define F3	  0xB
#define NF0   0xC
#define NF1   0xD
#define NF2   0xE
#define NF3   0xF
#define C	 0x10
#define NC	 0x11
#define Z	 0x12
#define NZ	 0x13

/*
 * Symbol types
 */
#define S_IMMED 30
#define S_R8	31
#define S_R8X	32
#define S_R16	33
#define S_R16X	34
#define S_CND	35
#define S_FLAG	36

/*
 * Indexing modes
 */
#define S_INDB	40
#define S_IDC	41

#define S_INDR	50
#define S_IDHL	(S_INDR+HL)
#define S_IDIX	(S_INDR+IX)
#define S_IDIY	(S_INDR+IY)

#define S_INDM	57

/*
 * Instruction types
 */
#define S_LD	60
#define S_CALL	61
#define S_JP	62
#define S_OR	63
#define S_JRS	64
#define S_BIT	65
#define S_INC	66
#define S_XOR	67
#define S_ADD	68
#define S_ADC	69
#define S_AND	70
#define S_EX	71
#define S_PUSH	72
#define S_IN	73
#define S_OUT	74
#define S_RL	75
#define S_INT	77
#define S_INH1	78
#define S_INH2	79
#define S_DJR	80
#define S_CP	81
#define S_SBC	82
#define S_CARS	83
#define S_JRL	84
#define S_CARL	85
#define S_SWAP	95

struct adsym
{
		char	a_str[4];		/* addressing string */
		int		a_val;			/* addressing mode value */
};

extern	struct	adsym	R8[];
extern	struct	adsym	R8X[];
extern	struct	adsym	R16[];
extern	struct	adsym	R16X[];
extern	struct	adsym	CND[];

		/* machine dependent functions */

		/* SMCadr.c */
extern	int				addr();
extern	int				admode();
extern	int				any();
extern	int				srch();

		/* SMCmch.c */
extern	VOID			comma();
extern	int				genop();
extern	int				gixiy();
extern	VOID			machin();
extern	VOID			minit();
