/* smcadr.c */

/*
 * (C) Copyright 1989,1990
 * All Rights Reserved
 *
 * Alan R. Baldwin
 * 721 Berkeley St.
 * Kent, Ohio  44240
 *
 * Modified for SMC88
 * (c) Copyright 1995
 *
 * Altair in Planning Group "HALO"
 * NBG01720@niftyserve.or.jp
 */

#include<stdio.h>
#include<setjmp.h>
#include"asm.h"
#include"smc.h"

/*
 * Read an address specifier. Pack the
 * address information into the supplied
 * `expr' structure. Return the mode of
 * the address.
 *
 * This addr(esp) routine performs the following addressing decoding:
 *
 *		address			mode			flag			addr			base
 *		#n				S_IMMED			0				n				NULL
 *		label			s_type			----			s_addr			s_area
 *		[REG]			S_IND+icode		0				0				NULL
 *		[label]			S_INDM			----			s_addr			s_area
 *		offset[REG]		S_IND+icode		----			offset			----
 */
int
addr(esp)
register struct expr *esp;
{
		register c, mode, indx;

		if ((c = getnb()) == '#') {
				expr(esp, 0);
				esp->e_mode = S_IMMED;
		} else
		if (c == LFIND) {
				if ((indx = admode(R8)) != 0) {
						mode = S_INDB;
				} else
				if ((indx = admode(R16)) != 0) {
						mode = S_INDR;
				} else
				if ((indx = admode(R8X)) != 0) {
						mode = S_R8X;
						aerr();
				} else
				if ((indx = admode(R16X)) != 0) {
						mode = S_R16X;
						aerr();
				} else {
						expr(esp, 0);
						esp->e_mode = S_INDM;
				}
				if (indx) {
						esp->e_flag = 0;
						esp->e_addr = 0;
						esp->e_mode = mode + indx&0xFF;
						esp->e_base.e_ap = NULL;
				}
				if ((c = getnb()) != RTIND)
					qerr();
		} else {
				unget(c);
				if ((indx = admode(R8)) != 0) {
						mode = S_R8;
				} else
				if ((indx = admode(R16)) != 0) {
						mode = S_R16;
				} else
				if ((indx = admode(R8X)) != 0) {
						mode = S_R8X;
				} else
				if ((indx = admode(R16X)) != 0) {
						mode = S_R16X;
				} else {
						expr(esp, 0);
						esp->e_mode = S_USER;
				}
				if (indx) {
						esp->e_flag = 0;
						esp->e_addr = indx&0xFF;
						esp->e_mode = mode;
						esp->e_base.e_ap = NULL;
				}
				if ((c = getnb()) == LFIND) {
						if ((indx=admode(R16))!=0
								&& ((indx&0xFF)==IX || (indx&0xFF)==IY)) {
								esp->e_mode = S_INDR + (indx&0xFF);
						} else {
								aerr();
						}
						if ((c = getnb()) != RTIND)
								qerr();
				} else {
						unget(c);
				}
		}
		return (esp->e_mode);
}

/*
 * Enter admode() to search a specific addressing mode table
 * for a match. Return the addressing value on a match or
 * zero for no match.
 */
int
admode(sp)
register struct adsym *sp;
{
		register char *ptr;
		register int i;
		unget(getnb());
		i = 0;
		while ( *(ptr = (char *) &sp[i]) ) {
				if (srch(ptr)) {
						return(sp[i].a_val);
				}
				i++;
		}
		return(0);
}

/*
 *		srch --- does string match ?
 */
int srch(register char*str)
{	register char*ptr;
	ptr=ip;
#if CASE_SENSITIVE
	while(*ptr&&*str)
	{	if(*ptr!= *str)
			break;
		ptr++;
		str++;
	}
	if(*ptr==*str)
	{	ip=ptr;
		return 1;
	}
#else
	while(*ptr&&*str)
	{	if(ccase[*ptr]!=ccase[*str])
			break;
		ptr++;
		str++;
	}
	if(ccase[*ptr]==ccase[*str])
	{	ip=ptr;
		return 1;
	}
#endif

	if (!*str)
		if(any(*ptr," \t\n,);]"))
		{	ip = ptr;
			return 1;
		}
	return 0;
}

/*
 *		any --- does str contain c?
 */
int
any(c,str)
char	c, *str;
{
		while (*str)
				if(*str++ == c)
						return(1);
		return(0);
}

/*
 * Registers
 */

struct adsym R8[]=
{	"a",	A|0400,
	"b",	B|0400,
	"l",	L|0400,
	"h",	H|0400,
	"",		0
};

struct adsym R8X[]=
{	"br",	BR|0400,
	"sc",	SC|0400,
	"nb",	NB|0400,
	"ep",	EP|0400,
	"xp",	XP|0400,
	"yp",	YP|0400,
	"",		0
};

struct adsym R16[]=
{	"ba",	BA|0400,
	"hl",	HL|0400,
	"ix",	IX|0400,
	"iy",	IY|0400,
	"sp",	SP|0400,
	"pc",	PC|0400,
	"",		0
};

struct adsym R16X[]=
{	"ip",	 IP|0400,
	"all",	ALL|0400,
	"ale",	ALE|0400,
	"",		0
};

/*
 * Conditional definitions
 */

struct adsym CND[]=
{	"NZ",	NZ|0400,
	"Z",	Z |0400,
	"NC",	NC|0400,
	"C",	C |0400,
	"LT",	LT|0400,
	"LE",	LE|0400,
	"GT",	GT|0400,
	"GE",	GE|0400,
	"V",	V |0400,
	"NV",	NV|0400,
	"P",	P |0400,
	"M",	M |0400,
	"F0",	F0|0400,
	"F1",	F1|0400,
	"F2",	F2|0400,
	"F3",	F3|0400,
	"NF0", NF0|0400,
	"NF1", NF1|0400,
	"NF2", NF2|0400,
	"NF3", NF3|0400,
	"",		0
};
