/* smcmch.c */

/*
 * (c) Copyright 1995
 *
 * Altair in Planning Group "HALO"
 * NBG01720@niftyserve.or.jp
 */

#include<stdio.h>
#include<setjmp.h>
#include"asm.h"
#include"smc.h"

/*
 * Process a machine op.
 */
void machine(struct mne*mp)
{	register op, t1, t2;
	struct expr e1, e2;
	int rf, v1, v2;

	op = mp->m_valu;
	rf = mp->m_type;
	switch (rf)
	{	case S_LD:
			t1=addr(&e1);
			t2=0;
			if(more())
			{	comma();
				t2=addr(&e2);
			}
			v1=7;
			v2=0xDC;
			switch(t1)
			{	case S_IDHL:
					if(e1.e_addr)
						goto S_aerr;
					op+=8;	--v1;	v2-=16;
				case S_IDIX:
					op-=16; --v1;	v2-=8;
				case S_IDIY:
					if(e1.e_addr)
					{	if(t2!=S_R8)
							goto S_aerr;
						switch(e2.e_addr)
						{	case A:op=0x44-6;	break;
							case B:op=0x4C-6;	break;
							case L:op=0x54-6;	break;
							case H:op=0x5C-6;
						}
						outab(0xCE);
						outab(op+v1);
						outrb(&e1,0);
						break;
					}
					op+=0x30;
					if(t2>=S_INDR&&e2.e_addr)
						op^=8;
					else
						if(t2==S_R16)
						{	if(e2.e_addr>=SP)
								goto S_aerr;
							outab(0xCF);
							outab(v2+e2.e_addr);
							break;
						}else
							switch(t2)
							{	case S_IMMED:
									e1.e_addr=v1;
									goto S_LD_IMMED;

								case S_USER:
								case S_R8X:
									goto S_aerr;
							}
				case S_R8:
					switch(t2)
					{	case S_R8X:
							if(e1.e_addr!=A)
								goto S_aerr;
							outab(0xCE);
							op+=0x80;
						case S_R8:
							outab(op+e1.e_addr*8+e2.e_addr);
							break;

						case S_USER:
							outab(0xCE);
							outab(0xD0+e1.e_addr);
							outrw(&e2,0);
							break;

						case S_IDIY:
							++op;
						case S_IDIX:
							if(e2.e_addr)
							{	outab(0xCE);
								outab(op+e1.e_addr*8);
								outrb(&e2,0);
							}else
								outab(op+e1.e_addr*8+6);
							break;

						case S_IMMED:
S_LD_IMMED:						outab(0xB0+e1.e_addr);
								outab(e2.e_addr);
								break;

						case S_IDHL:
							if(!e2.e_addr)
							{	outab(op+e1.e_addr*8+5);
								break;
							}
						default:
							goto S_aerr;
					}
					break;

				case S_USER:
					switch(t2)
					{	case S_R8:
							outab(0xCE);
							outab(0xD4+e2.e_addr);
							break;

						case S_R16:
							if(e2.e_addr<=SP)
							{	if(e2.e_addr!=SP)
									outab(0xBC+e2.e_addr);
								else
									outaw(0x7CCF);
								break;
							}
						default:
							goto S_aerr;
					}
					outrw(&e1,0);
					break;

				case S_R8X:
					switch(t2)
					{	case S_IMMED:
							switch(e1.e_addr)
							{	case BR:
									op=0xB4;
									break;

								case SC:
									op=0x9F;
									break;

								default:
									outab(0xCE);
									op=0xBC+e1.e_addr;
							}
							outab(op);
							outab(e2.e_addr);
							break;

						case S_R8:
							if(e2.e_addr==A)
							{	if(e1.e_addr>=NB)
									e1.e_addr+=2;
								outab(0xCE);
								outab(e1.e_addr+0xC2);
								break;
							}
						default:
							goto S_aerr;
					}
					break;

				case S_R16:
					if(e1.e_addr==PC)
						goto S_aerr;
					switch(t2)
					{	case S_R16:
							t1=0xCF;
							switch(e2.e_addr)
							{	case PC:
									if(e1.e_addr>HL)
										goto S_aerr;
									--t1;
								case SP:
									switch(e1.e_addr)
									{	case BA:op=0xF8-SP; break;
										case HL:op=0xF4-SP; break;
										case IX:op=0xFA-SP; break;
										case IY:op=0xfe - SP;break;
										default:goto S_aerr;
									}
									op+=e2.e_addr;
									break;

								default:
									if(e2.e_addr>=SP)
										e2.e_addr+=0x10;
									if(e1.e_addr==SP)
										e1.e_addr>>=1;
									op=0xE0+e1.e_addr*4+e2.e_addr;
							}
							outab(t1);
							outab(op);
							break;

						case S_IMMED:
							switch(e1.e_addr)
							{	case SP:outab(0xCF);
										op=0x6E;
										break;

								case PC:goto S_aerr;

								default:op=0xC4+e1.e_addr;
							}
							outab(op);
							outaw(e2.e_addr);
							break;

						case S_USER:
							switch(e1.e_addr)
							{	case SP:outaw(0x78CF);	break;

								case PC:goto S_aerr;

								default:outab(0xB8+e1.e_addr);
							}
							outrw(&e2,0);
							break;

						case S_IDHL:
							op=0xC0;
S_LD_R16_INDR:				if(e1.e_addr==SP)
								goto S_aerr;
							outab(0xCF);
							outab(op+e1.e_addr);
							break;

						case S_IDIX:
							op=0xD0;
							goto S_LD_R16_INDR;

						case S_IDIY:op=0xD8;
							goto S_LD_R16_INDR;
						default:
							if(t2<S_INDR)
								goto S_aerr;
					}
					break;

				default:
S_aerr:				aerr();
			}
			break;

		case S_CALL:
			expr(&e1,0);
			outab(op);
			outrw(&e1,0);
			break;

		case S_JP:
			switch(addr(&e1))
			{	case S_USER:
					outab(op);
					if(e1.e_addr>=256)
						aerr();
					outrb(&e1,0);
					break;

				case S_R16:
					if(e1.e_addr==HL)
					{	outab(0xF4);
						break;
					}
				default:
					aerr();
			}
			break;

		case S_BIT:
			t1=addr(&e1);
			t2=0;
			if(more())
			{	comma();
				t2=addr(&e2);
			}
			switch(t2)
			{	case S_IMMED:
					switch(t1)
					{	case S_R8:
							if(e1.e_addr<=B)
								outab(op+e1.e_addr);
							else
								aerr();
							break;

						case S_IDHL:
							if(e1.e_addr==0)
							{	outab(0x95);
								break;
							}
						default:
							aerr();
					}
					outab(e2.e_addr);
					break;

				case S_R8:
					if(e2.e_addr==B&&t1==S_R8&&e1.e_addr==A)
					{	outab(0x94);
						break;
					}
				default:
					aerr();
			}
			break;

		case S_SWAP:
			switch(addr(&e1))
			{	case S_R8:
					if(e1.e_addr==A)
					{	outab(0xF6);
						break;
					}else
					break;

				case S_IDHL:
					if(!e1.e_addr)
					{	outab(0xF7);
						break;
					}
				default:
					aerr();
			}
			break;

		case S_EX:
			t1=addr(&e1);
			t2=0;
			if(more())
			{	comma();
				t2=addr(&e2);
			}
			switch(t1)
			{	case S_R8:
					if(!e1.e_addr)
					{	switch(t2)
						{	case S_R8:
								if(e2.e_addr==B)
									outab(0xCC);
								else
									aerr();
								break;

							case S_IDHL:
								if(!e2.e_addr)
								{	outab(0xCD);
									break;
								}
							default:
								aerr();
						}
					}else
						aerr();
					break;

				case S_R16:
					if(e1.e_addr==BA&&t2==S_R16)
					{	switch(e2.e_addr)
						{	case BA:aerr();
									break;

							case SP:e2.e_addr=4;
							default:outab(op+e2.e_addr);
						}
						break;
					}
				default:
					aerr();
			}
			break;

		case S_OR:
		case S_AND:
		case S_CP:
		case S_ADD:
		case S_ADC:
		case S_SBC:
			t1=addr(&e1);
			t2=0;
			if(more())
			{	comma();
				t2=addr(&e2);
			}
			switch(t1)
			{	case S_R8:
					if(e1.e_addr==A)
					{	switch(t2)
						{	case S_IMMED:
								outab(op+2);
								outab(e2.e_addr);
								break;

							case S_USER:
								outab(op+5);
								outrw(&e2,0);
								break;

							case S_IDIY:
								++op;
							case S_IDIX:
								if(e2.e_addr)
								{	outab(0xCE);
									outab(op);
									outrb(&e2,0);
								}else
									outab(op+6);
								break;

							case S_IDHL:
								outab(op+3);
								if(e2.e_addr)
									aerr();
								break;

							case S_R8:
								if(e2.e_addr<=B)
								{	outab(op+e2.e_addr);
									break;
								}
							default:
								aerr();
						}
					}else
					{	switch(rf)
						{	case S_OR:
							case S_CP:	op^=0xC;
							case S_AND: if(t2==S_IMMED)
										{	outab(0xCE);
											outab(op|e1.e_addr-1|0xB0);
											outab(e2.e_addr);
											break;
										}
							default:	aerr();
						}
					}
					break;

				case S_R8X:
					if(e1.e_addr!=SC)
						aerr();
					else
					{	switch(op)
						{	case 0x30:	outab(0xCE);
										op=0xBF;
										break;

							case 0x20:	op=0x9C;	break;

							case 0x28:	op=0x9D;	break;

							case 0x38:	op=0x9E;	break;

							default:	aerr();
						}
						outab(op);
						outab(e2.e_addr);
					}
					break;

				case S_IDHL:
					if(e1.e_addr)
						aerr();
					outab(0xCE);
					switch(t2)
					{	case S_IDIY:	++op;
						case S_IDIX:	op+=6;
										if(e2.e_addr)
											aerr();
										break;

						case S_IMMED:	outab(op+5);
										op=e2.e_addr;
										break;

						case S_R8:		if(e2.e_addr==A)
										{	op+=4;
											break;
										}
						default:		aerr();
					}
					outab(op);	break;

				case S_R16:
					if(rf!=S_AND&&rf!=S_OR)
					{	switch(t2)
						{	case S_IMMED:
								if(op&8)
								{	if(e1.e_addr>HL)
									{	aerr();
										break;
									}
X_ADD:								outab(0xCF);
									outab((op&0x10)>>3|e1.e_addr|0x60);
								}else
									if(e1.e_addr==SP)
										if(rf==S_CP)
											outaw(0x6CCF);
										else
											goto X_ADD;
									else
										outab(op+(rf!=S_CP?0xC0:0xA4)+e1.e_addr);
								outaw(e2.e_addr);
								break;

							case S_R16:
								op>>=1;
								switch(e1.e_addr)
								{	case SP:op+=2;
									case IY:op+=2;
									case IX:op+=0x20;
											switch(rf)
											{	case S_ADC:
												case S_SBC: aerr();
											}
									case HL:op+=0x20;
									default:outab(0xCF);
											outab(op+e2.e_addr);
								}
								break;

							default:aerr();
						}
						break;
					}
				default:
					aerr();
			}
			break;

		case S_PUSH:
			switch(addr(&e1))
			{	case S_R8:	e1.e_addr+=16;
				case S_R16X:if(e1.e_addr!=IP)
							{	e1.e_addr-=op>>1&4;
								outab(0xCF);
							}
							break;

				case S_R8X: switch(e1.e_addr)
							{	case BR:e1.e_addr=4;	break;
								case SC:e1.e_addr=7;	break;
								case EP:e1.e_addr=5;	break;
								default:aerr();
							}
							break;

				case S_R16: if(e1.e_addr!=SP)
								break;
				default:	aerr();
			}
			outab(op+e1.e_addr);
			break;

		case S_RL:
			switch(addr(&e1))
			{	case S_R8:	if(e1.e_addr>B)
								aerr();
							break;

				case S_IDHL:if(e1.e_addr==0)
							{	e1.e_addr=3;
								break;
							}
				default:	aerr();
			}
			outab(0xCE);
			outab(op+e1.e_addr);
			break;

		case S_INC:
			switch(addr(&e1))
			{	case S_R8X: if(e1.e_addr==BR)
								e1.e_addr=4;
				case S_R8:	break;

				case S_R16: e1.e_addr=e1.e_addr==SP?7:e1.e_addr+0x10;
							break;

				case S_IDHL:if(e1.e_addr==0)
							{	e1.e_addr=6;
								break;
							}
				default:	aerr();
			}
			outab(op+e1.e_addr);
			break;

		case S_INT:
			expr(&e1,0);
			outab(op);
			if(e1.e_addr>=256)
				aerr();
			outrb(&e1,0);
			break;

		case S_INH2:
			outab(0xCE);
		case S_INH1:
			outab(op);
			break;

		case S_JRS:
		case S_CARS:
			if((v1=admode(CND))!=0)
			{	if((v1&=0xFF)<=NF3)
				{	outab(0xCE);
					op+=v1;
				}else
				{	if(rf==S_JRS)
						op=0xE4;
					else/*S_CARS*/
					{	op=0xE0;
						if(v1!=C)
							aerr();
					}
					op+=v1&0xF;
				}
				comma();
			}else
				op=(rf==S_JRS)?0xF1:0xF0;
S_JRS0:		expr(&e2, 0);
			outab(op);
			if(e2.e_base.e_ap==NULL||e2.e_base.e_ap==dot.s_area)
			{	v2 = e2.e_addr - dot.s_addr;
				if ((v2 < -128) || (v2 > 127))
					aerr();
				outab(v2);
			} else
				outrb(&e2, R_PCR);
			if (e2.e_mode != S_USER)
				rerr();
			break;

		case S_DJR:
			if(admode(CND)==(NZ|0400))
				comma();
			else
				aerr();
			goto S_JRS0;

		case S_JRL:
		case S_CARL:
			if((v1=admode(CND))!=0)
			{	if(v1&0x10)
					op+=v1&0xF;
				else
					aerr();
				comma();
			}else
				op=(rf==S_JRL)?0xF3:0xF2;
			expr(&e2, 0);
			outab(op);
			if(e2.e_base.e_ap==NULL||e2.e_base.e_ap==dot.s_area)
				outaw(e2.e_addr-dot.s_addr-1);
			else
				outrw(&e2,R_PCR);
			if(e2.e_mode!=S_USER)
				rerr();
			break;

		default:
			err('o');
	}
}

/*
 * The next character must be a comma
 */
void comma()
{	if(getnb()!=',')
		qerr();
}

/*
 * Machine dependent initialization
 */
void minit()
{
}
