#!/usr/bin/perl

while(<>) {
    if (/(lod|LOD) ([0123456789ABCDEFabcdef]+)[Hh]/) {
	$val = (hex($2) & 0xffff);
	s/lod [0123456789ABCDEFabcdef]+/$val/g;
    } elsif (/(lod|LOD) ([0123456789]+)/) {
	$val = $2 & 0xffff;
	s/(lod|LOD) [0123456789]+/$val/g;
    } elsif (/(lod|LOD) (\w+)/) {
	$val = $2;
	s/(lod|LOD) \w+/$val/;
    }

    if (/[\W](pod|POD) ([0123456789ABCDEFabcdef]+)[Hh]/) {
	$val = (hex($2) >> 16) & 0xff;
	s/(pod|POD) [0123456789ABCDEFabcdef]+/$val/g;
    } elsif (/[\W](pod|POD) ([0123456789]+)/) {
	$val = (hex($2) >> 16) & 0xff;
	s/(pod|POD) [0123456789]+/$val/g;
    } elsif (/[\W](pod|POD) /) {
	s/(pod|POD) \w+/0x10/g;
    }

    if (/[\W](loc|LOC) ([0123456789ABCDEFabcdef]+)[Hh]/) {
	$val = (hex($2) & 0xffff);
	s/(loc|LOC) [0123456789ABCDEFabcdef]+/$val/g;
    } elsif (/[\W](loc|LOC) ([0123456789]+)/) {
	$val = $2 & 0xffff;
	s/(loc|LOC) [0123456789]+/$val/g;
    } elsif (/[\W](loc|LOC) (\w+)/) {
	$val = $2;
	s/(loc|LOC) \w+/$val/;
    }

    s/([0123456789ABCDEFabcdef]+)[Hh]/0x$1/g;

    s/\sdata\s/\t\.area _AR_DATA_ \(REL,CON\) /;
    s/\scode\s/\t\.area _AR_CODE_ \(REL,CON\) /;

    s/external/\t\.globl /;
    s/\sdb\s/\t\.db /;
    s/\sdw\s/\t\.dw /;
    s/\send\s//;
    s/\sascii\s/\t\.ascii /;
    s/\s(jr|JR)\s/\tjrl\t/;

    s/;.*\n/\n/;
    /\S/ || next;
    
    print ;
}
