#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

void	Include(char *);
void	Define(char *);
void	Ifc(char *);
void	Ifdef(char *);
void	Ifndef(char *);
void	Elsec(char *);
void	Endif(char *);
void	Jis(char *);

FILE	*ofp = stdout;
int	lno[32];
int	lnoFlg = 0;
char	fname[32][64];
FILE	*fp[32];
int	fpNest = 0;
int	ten[32];
int	tenNest = 0;
int	defListFlg = 0;
int	comFlg = 1;
char	incPath[20][64];
int	incPathCnt = 0;

struct DEFINE	{
	int	attr;
	char	*defname;
	char	*change;
}
	DEFTbl[512];
int	DEFCnt = 0;

struct DIRECTIVE	{
	char	*directive;
	void	(*dfunc)(char *);
}
	DIRTbl[] = {
		{"include",	Include},
		{"define",	Define},
		{"ifndef",	Ifndef},
		{"ifdef",	Ifdef},
		{"ifc",		Ifc},
		{"if",		Ifc},
		{"elsec",	Elsec},
		{"else",	Elsec},
		{"endif",	Endif},
		{"$jis",	Jis},
		{NULL,		NULL}
	};


int	isalnum_(int n)
{
	return(isalnum(n) || (n == '_'));
}

char	*SkipSpace(char *src)
{
	while(*src && isspace(*src))
		++src;
	return(src);
}

char	*CopyNoSpace(char *dst,char *src)
{
	while(*src && !isspace(*src))
		*dst++ = *src++;
	*dst = '\0';
	return(src);
}

char	*CutSpace(char *src)
{
	static	char	dst[256];

	src = SkipSpace(src);
	strcpy(dst,src);
	src = &dst[strlen(dst) - 1];
	while(isspace(*src))
		*src-- = '\0';
	return(dst);
}

char	*GetToken(char *buf)
{
	static	char	rslt[256];
	char	*p;

	if(*(p = SkipSpace(buf)) == '\0')
		return(NULL);
	p = CopyNoSpace(rslt,p);
	strcpy(buf,p);
	return(rslt);
}

struct DEFINE	*SearchDefine(char *name)
{
	int	i;

	for(i = 0; i < DEFCnt; i++) {
		if(!strcmp(name,DEFTbl[i].defname))
			return(&DEFTbl[i]);
	}
	return(NULL);
}

void	ChangeDefine(char *buf)
{
	int	i,j;
	char	defn[256],*p;
	char	srcbuf[256];
	char	param[10][64],*ps,*pd;

	for(i = 0; i < DEFCnt; i++) {
		if(DEFTbl[i].attr == 0) {
			p = buf;
			while(p != NULL) {
				if((p = strstr(p,DEFTbl[i].defname)) != NULL) {
					if(((p == buf) || !isalnum_(p[-1])) && (!isalnum_(p[strlen(DEFTbl[i].defname)]))) {
					  	strcpy(srcbuf,&p[strlen(DEFTbl[i].defname)]);
						strcpy(p,DEFTbl[i].change);
						p = p + strlen(p);
						strcpy(p,srcbuf);
					}
					else
						++p;
				}
			}
		}
	}
	memset(param,'\0',sizeof(param));
	for(i = 0; i < DEFCnt; i++) {
		if(DEFTbl[i].attr == 1) {
			p = buf;
			while(p != NULL) {
				if((p = strstr(p,DEFTbl[i].defname)) != NULL) {
					if(((p == buf) || !isalnum_(p[-1])) && (!isalnum_(p[strlen(DEFTbl[i].defname)]))) {
						ps = CutSpace(&p[strlen(DEFTbl[i].defname)]);
						j = 0;
						pd = param[0];
						while(*ps) {
							if(*ps == ',') {
								strcpy(param[j],CutSpace(param[j]));
								pd = param[++j];
								++ps;
							}
							else
								*pd++ = *ps++;
						}
						strcpy(param[j],CutSpace(param[j]));
						ps = DEFTbl[i].change;
						while(*ps) {
							if(*ps == '%') {
								pd = param[(*++ps) - '0'];
								while(*pd)
									*p++ = *pd++;
								++ps;
							}
							else
								*p++ = *ps++;
						}
						*p = '\0';

						i = DEFCnt;
						break;
					}
					else
						++p;
				}
			}
		}
	}
}

void	Error(int no,char *ext)
{
	char	*msg;

	switch(no) {
	case 1:
		msg = "File or Path not found";
		break;
	case 2:
		msg = "Macro buffer overflow";
		break;
	case 3:
		msg = "Out of memory in";
		break;
	case 4:
		msg = "endm not found";
		break;
	case 5:
		msg = "File not open";
		break;
	}
	fprintf(stderr,"spp88: %s %s\n",msg,ext);
	exit(no);
}

void	Include(char *dat)
{
	int	i;
	char	fn[64];

	++fpNest;
	strcpy(fname[fpNest],CutSpace(dat));
	if((fp[fpNest] = fopen(fname[fpNest],"rt")) == NULL) {
		for(i = 0; i < incPathCnt; i++) {
			sprintf(fn,"%s/%s",incPath[i],fname[fpNest]);
			if((fp[fpNest] = fopen(fn,"rt")) != NULL)
				break;
		}
		if(i == incPathCnt)
			Error(1,fname[fpNest]);
	}
	lno[fpNest] = 0;
}

void	Define(char *dat)
{
	char	defn[256],*p;

	if(DEFCnt == 512)
		Error(2,dat);

	ChangeDefine(dat);
	DEFTbl[DEFCnt].attr = 0;
	dat = SkipSpace(dat);
	dat = CopyNoSpace(defn,dat);
	if((DEFTbl[DEFCnt].defname = strdup(defn)) == NULL)
		Error(3,"Define");

	dat = SkipSpace(dat);
	p = defn;
	while(*dat && (*dat != ';'))
		*p++ = *dat++;
	*p = '\0';
	if((DEFTbl[DEFCnt].change = strdup(CutSpace(defn))) == NULL)
		Error(3,"Define");
	++DEFCnt;
}

void	Ifc(char *dat)
{
	struct DEFINE	*p;

	ten[++tenNest] = 0;
	if(atoi(dat) != 0)
		ten[tenNest] = 1;
	else if((p = SearchDefine(CutSpace(dat))) != NULL) {
		if(atoi(p->change) != 0)
			ten[tenNest] = 1;
	}
}

void	Ifdef(char *dat)
{
	ten[++tenNest] = 0;
	if(SearchDefine(CutSpace(dat)) != NULL)
		ten[tenNest] = 1;
}

void	Ifndef(char *dat)
{
	ten[++tenNest] = 0;
	if(SearchDefine(CutSpace(dat)) == NULL)
		ten[tenNest] = 1;
}

void	Elsec(char *dat)
{
	if(ten[tenNest])
		ten[tenNest] = 0;
	else
		ten[tenNest] = 1;
}

void	Endif(char *dat)
{
	--tenNest;
}

void	Jis(char *dat)
{
	++dat;
	fprintf(ofp,"db\t");
	while(*dat) {
		fprintf(ofp,"%03xh",*dat++);
		if(*dat && (*dat != '\n'))
			fputc(',',ofp);
	}
	fputc('\n',ofp);
}

int	DirectiveFork(char *src)
{
	int	i,n;

	for(i = 0; DIRTbl[i].directive != NULL; i++) {
		n = strlen(DIRTbl[i].directive);
		if(!memcmp(src,DIRTbl[i].directive,n)) {
			(DIRTbl[i].dfunc)(src + n);
			return(0);
		}
	}
	return(1);
}

void	Macro(char *buf)
{
	char	param[10][64];
	char	mbuf[256],*s,*d;
	char	*defs;
	int	pnum = 0;
	int	i;

	while(*buf) {
		buf = SkipSpace(buf);
		if(*buf) {
			d = param[pnum];
			while(*buf && (*buf != ','))
				*d++ = *buf++;
			*d = '\0';
			if(*buf)
				++buf;
			strcpy(param[pnum],CutSpace(param[pnum]));
			++pnum;
		}
	}

	if((d = defs = malloc(2048)) == NULL)
		Error(3,"Macro");

	while(1) {
		if(fgets(mbuf,sizeof(mbuf),fp[fpNest]) <= 0)
			Error(4,"Macro");

		++lno[fpNest];

		if(strstr(mbuf,"endm") != NULL)
			break;

		s = mbuf;
		while(*s) {
			for(i = 0; i < pnum; i++) {
				if(!memcmp(s,param[i],strlen(param[i])))
					break;
			}
			if(i == pnum)
				*d++ = *s++;
			else {
				*d++ = '%';
				*d++ = i + '0';
				s = s + strlen(param[i]);
			}
		}
	}
	*d = '\0';
	ChangeDefine(defs);
	if((DEFTbl[DEFCnt].change = strdup(defs)) == NULL)
		Error(3,"Macro");

	free(defs);
}

int	AsmFork(char *src)
{
	char	lbl[256];

	src = CopyNoSpace(lbl,src);
	src = SkipSpace(src);
	if(!memcmp(src,"equ",3)) {
		DEFTbl[DEFCnt].attr = 2;
		if((DEFTbl[DEFCnt].defname = strdup(lbl)) == NULL)
			Error(3,"equ");

		if((DEFTbl[DEFCnt].change = strdup(CutSpace(src + 3))) == NULL)
			Error(3,"equ");

		++DEFCnt;
		return(1);
	}
	if(!memcmp(src,"macro",5)) {
		DEFTbl[DEFCnt].attr = 1;
		if((DEFTbl[DEFCnt].defname = strdup(lbl)) == NULL)
			Error(3,"macro");

		Macro(src + 5);
		++DEFCnt;
		return(0);
	}
	return(1);
}

int	main(int ac, char *av[])
{
	int	i;
	int	rslt = 0;
	char	buf[2048],*p;
	char	com[256],spc[256],*sp;

	if((sp = getenv("SPP88")) != NULL)
		sp = &buf[sprintf(buf,"%s ",sp)];
	else
		*(sp = buf) = '\0';
	for(i = 1; i < ac; i++)
		sp += sprintf(sp,"%s ",av[i]);

	strcpy(com,"stdin");
	strcpy(spc,"stdout");
	fp[fpNest = 0] = stdin;
	while((sp = GetToken(buf)) != NULL) {
		if((sp[0] == '-') || (sp[0] == '/')) {
			switch(sp[1]) {
			case 'v':
				fputs(
				  "SPP88 smc88 assembler pre-processer Version 0.2\n"
				  "Copyright (C) 1995 by Miki Hoshino\n",stderr);
				break;
			case 'o':
				if((sp = GetToken(buf)) != NULL) {
					if((ofp = fopen(sp,"wt")) == NULL)
						Error(5,sp);
					strcpy(spc,sp);
				}
				else
					Error(1,"<Nothing>");
				break;
			case 'l':
				if(sp[2] == '-')
					lnoFlg = 0;
				else
					lnoFlg = 1;
				break;
			case 'd':
				defListFlg = 1;
				break;
			case 'c':
				if(sp[2] == '-')
					comFlg = 1;
				else
					comFlg = 0;
				break;
			case 'i':
				if((sp = GetToken(buf)) != NULL)
					strcpy(incPath[incPathCnt++],sp);
				else
					Error(1,"<Nothing>");
				break;
			default:
				fputs(
				  "Usage: spp88 [-v][-o OutputName][-l][-c][-i IncludePath] [InputName]\n"
				  "  -v   version info.\n"
				  "  -o   output file\n"
				  "  -l   line no. usage\n"
				  "  -c   delete comment\n"
				  "  -i   add include search path\n"
				  "     * OutputName defaults   stdout\n"
				  "       InputName defaults    stdin\n"
				  ,stderr);
				return(0);
			}
		}
		else {
			if((fp[fpNest] = fopen(sp,"rt")) == NULL)
				Error(1,sp);
			strcpy(fname[fpNest],sp);
			strcpy(com,sp);
		}
	}
	if(defListFlg) {
		fprintf(stderr,"-l%s -c%s ",lnoFlg?"":"-",comFlg?"-":"");
		for(i = 0; i < incPathCnt; i++)
			fprintf(stderr,"-i %s ",incPath[i]);
		fprintf(stderr,"-o %s %s\n",spc,com);
	}
	lno[fpNest] = 0;
	ten[tenNest] = 1;
	while(fpNest >= 0) {
		while(!feof(fp[fpNest])) {
			if(fgets(buf,sizeof(buf),fp[fpNest]) <= 0)
				break;
			++lno[fpNest];
			if(*(p = &buf[strlen(buf) - 1]) == '\n')
				*p = '\0';
			p = buf;
			i = 1;
			com[0] = '\0';
			while(*p) {
				if(*p == '\'')
					i = !i;
				if(i && (*p == ';')) {
					strcpy(com,p);
					*p = '\0';
					break;
				}
				++p;
			}
			p = buf;
			sp = spc;
			while(*p) {
				if(isspace(*p))
					*sp++ = *p++;
				else {
					*sp = '\0';
					if(DirectiveFork(p)) {
						ChangeDefine(p);
						if(AsmFork(p)) {
							if(ten[tenNest]) {
								fputs(spc,ofp);
								fputs(p,ofp);
								spc[0] = '*';
							}
						}
						else
							spc[0] = '\0';
					}
					else
						spc[0] = '\0';
					break;
				}
			}
			if(comFlg && com[0]) {
				fputs(com,ofp);
				spc[0] = '*';
			}
			if(spc[0] == '*') {
				if(lnoFlg)
					fprintf(ofp,"\t\t; %s\t%5d\n",fname[fpNest],lno[fpNest]);
				else
					fputc('\n',ofp);
			}
		}
		--fpNest;
	}
	if(defListFlg) {
		for(i = 0; i < DEFCnt; i++)
			fprintf(stderr,"Def\t%s\t%s\n",DEFTbl[i].defname,DEFTbl[i].change);
	}
	return(rslt);
}
